\documentclass{scrartcl}
\usepackage[top=1in, bottom=1.25in, left=1.25in, right=1.25in]{geometry}
\usepackage{array}
\usepackage[utf8x]{inputenc}
\usepackage[ngerman]{babel}
\usepackage{algorithm2e}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{lmodern}
\usepackage{stmaryrd}
%\usepackage{kpfonts}
\usepackage{tikz}
\usepackage{mathtools}
\usepackage{url}
\usepackage{microtype}
\DeclarePairedDelimiter{\ceil}{\lceil}{\rceil}	%Runden
\usetikzlibrary{trees}	%Bäume
\usetikzlibrary{positioning,calc,shapes,chains,arrows}

\setlength{\parindent}{0em}
\newcommand{\vcenteredinclude}[1]{\begingroup
\setbox0=\hbox{#1}%
\parbox{\wd0}{\box0}\endgroup}
\newcolumntype{P}[1]{>{\raggedright\arraybackslash}p{#1}}

\tikzset{
itria/.style={
  draw,dashed,shape border uses incircle,
  isosceles triangle,shape border rotate=90,yshift=-1.5cm}}

\pagenumbering{gobble}
\def\kuller{\bigcirc}
\newcommand{\shouldequal}{\overset{!}{=}}

\pagestyle{plain}

\begin{document}
\begin{center}$ $
{\fontsize{24}{10} \selectfont
\textbf{Artificial Life}$ $\\
$ $\\
\underline{Sheet 8}
}\\
\vspace{2em}
\begin{minipage}[t]{0.49\textwidth}
{\fontsize{15}{20} \raggedright \selectfont
Group \textbf{A}\\
Wed, 8-10h\\
$ $\\
}
\end{minipage}
\begin{minipage}[t]{0.49\textwidth}
{\fontsize{15}{20} \raggedleft \selectfont 
Tobias Kremeyer\\
}\end{minipage}
\end{center}
%\vspace{1em}
%{\fontsize{15}{20} \selectfont \setlength\extrarowheight{10pt}
%\begin{tabular}{|c||c|c||c|c||c|c||c|c||c|c|}
%\hline
%\textbf{Punkte:} & A1 & \hspace{1.7em} & A2 & \hspace{1.7em} & A3 & \hspace{1.7em} & A4 & \hspace{1.7em} & $\Sigma$ & \hspace{2.4em} \\
%\hline
%\end{tabular}}

\section*{A55) Hamming Cliffs}
For genomes where each allele is part of a finite set (e.g. $\{ 0,1 \}$), the hamming distance is defined as the number of positions where two genomes are different. A hamming cliff occurs if two genomes with similar phenotypes have a high hamming distance, for example for binary numbers: $31_{10} = 011111_2, 32_{10}=100000$ with hamming distance $6$. In this case, the phenotypes are similar (31 and 32 are very similar numbers) while the genotypes are very different (binary encoding looks completely different). For an evolutionary algorithm, it is difficult to pass this hamming cliff using genetic operators (a lot of bits would have to be flipped). Thus, small optimizations of the genomes are not probable to be created, because a big change of the genotype is required, which is a problem for the concept of Exploitation (converge to a local optimum in a fast way). However, hamming cliffs are positive when it comes to Exploration (consider different areas of the search space): When there are very different genotypes for similar phenotypes, there are also very different phenotypes for similar genotypes. For example, changing only the first bit of a binary number (genotype) yields a very different value of this number (phenotype). Thus, it is easily possible to ''jump around'' in the search space and explore it.\\
\textbf{Source:} Behnke, S. (2017) Computational Intelligence [Lecture slides]. 

\section*{A57) Popularity of EA}
\begin{itemize}
\item \textbf{Generality}: Evolutionary Algorithms are a general approach to solving lots of different types of problems. If the problem can be encoded in genomes and a fitness function, it can be already applied to an EA.
\item \textbf{Simplicity:} The most difficult things to think about are a fitness function and a genome encoding suitable for the problem. Beyond that, only methods for external and parent selection as well as mutation operators have to be chosen. For those things, there are enough general ''standard'' operators such that one only needs to choose the appropriate ones from this range of operators. Because of this, it is much more simple to apply an EA than elaborating a more ''direct'' solution.
\item \textbf{Past Experience:} Evolutionary Algorithms started as experiments to use a process observed in the nature to solve one's own problems. By experimenting and playing around with this type of algorithm, people in the scientific field gained experience about what works and what does not. Publications and papers as well as the experience show that for a lot of problems Evolutionary Algorithms do work. Therefore, more people use those algorithms and they are as popular as they are.
\end{itemize}

\section*{A58) Exploration vs Exploitation}
\subsection*{Exploration}
In each step, produce completely random genomes independently of the parents. This yields a trivial exploration behaviour. The algorithm does not converge to fixed areas in the search space.

\subsection*{Exploitation}
In each step, take exactly the parents as the new populations. This yields a trivial exploitation behaviour. The algorithm converges to a small fixed set of points and completely dismisses all other points in the search space.


\section*{A59) Using EAs to create candy bars}
\subsection*{Proposed EA Parameters}
\subsubsection*{Genome}
To apply an EA to our candy bar example, we need to encode each possible candy bar into a genome. Since there are $M=50$ possible ingredients plus sugar, chocolate and milk, we can make the genome have 53 values, each between 0 and 100, each indicating the percentage with which this ingredient is contained in the candy bar.\\
\textbf{Restrictions:} The 53 values in the genome shall add up to 100. Of the 50 ingredients apart from the first three, only up to $A=17$ shall be different than 0. The first 3 ingredients (sugar, chocolate, milk) each shall be greater than 0. None of the 50 ingredients apart from the first three shall exceed 3. If a produced genome does not meet this criteria, it shall be discarded and replaced by a new one.
\subsubsection*{Fitness Function}
We need a method to evaluate a genome by a fitness function. Since we have enough students that can test our creation, we can just produce it and let them rate it from 0 to 10 points. Then we can take the average as fitness value. Also, as an optimization, we could manually sort out obviously uneatable creations, like for example very little chocolate and a little milk with a lot of sugar and no additional ingredients and rate them with fitness 0 so our students will also be willed to test more candy bars in the future.
\subsubsection*{Inheritance}
To let multiple candy bars mate and produce a child candy bar, we can just take the average of all their ingredients. Since only 17 additional ingredients are allowed, we can then randomly discard ingredients until only 17 are left and normalize the values such that they add up to 100\% again.
\subsubsection*{Mutation}
To mutate a candy bar, we can subtract a random value from one ingredient and add it to another randomly selected ingredient. If the resulting candy bar is illegal, do this until a legal candy bar is yielded.
\subsubsection*{Selection}
For the external selection, we can order the genomes by their fitness values and then do a wheel-of-fortune-type selection. That way also worse genomes have the chance to get into the next generation. Above that, we can apply Elitism in order to preserve the best candy bars.\\
I propose to keep the 2 best candy bars and choose 4 more by the wheel of fortune such that we have 6 candy bars in the population.\\
For the parent selection, I propose to create 5 different subsets of 2 candy bars each and let them mate and mutate as described. Add those 5 new candy bars to the population, find their fitness values as described (if it is already known, use the fitness value from before) and select again.
\subsubsection*{Stopping Criterion}
If it becomes obvious that the fitness value does not increase very much over many populations, a good solution may have been found, thus a termination of the method is possible. However, we could just start to sell the candy bar and keep optimizing it, using for example sales figures.

\subsection*{Advantages and Problems}
In this example, you can see that a problem of EAs is to specify the representations as genomes. Some illegal cases are possible and we need to take care that such genomes do not stay in the population. Also, it is a problem to find the initial parameters for some methods and operators. For finding the optimal parameters, also experience is required. Beyond that, in this case, we have a fitness function which takes a lot of time and is expensive: Here, we need to produce a candy bar, let students taste and ask them how much they like it. So, each cycle costs some money and time and we need to select the parameters for the EA carefully such that there is a significant difference about the candy bars in every generation.\\
However, we can solve problems, which would be otherwise pretty difficult to solve, in an easy fashion, because not that much knowledge about the problem is required (Analyzing people's taste and how different combinations of ingredients affect it is much harder than just trying some combinations).

\end{document}